## org.mozilla.javascript.ast
Class ArrayComprehension

    java.lang.Object
      org.mozilla.javascript.Node
          org.mozilla.javascript.ast.AstNode
              org.mozilla.javascript.ast.Jump
                  org.mozilla.javascript.ast.Scope
                      org.mozilla.javascript.ast.ArrayComprehension

All Implemented Interfaces:
  java.lang.Comparable<AstNode>, java.lang.Iterable<Node>

    public class ArrayComprehension

extends Scope

AST node for a JavaScript 1.7 Array comprehension. Node type is `Token.ARRAYCOMP`.

Nested Class Summary

Nested classes/interfaces inherited from class org.mozilla.javascript.ast.AstNode
`AstNode.DebugPrintVisitor, AstNode.PositionComparator`

Nested classes/interfaces inherited from class org.mozilla.javascript.Node
`Node.NodeIterator`

Field Summary

Fields inherited from class org.mozilla.javascript.ast.Scope
`parentScope, symbolTable, top`

Fields inherited from class org.mozilla.javascript.ast.Jump
`target`

Fields inherited from class org.mozilla.javascript.ast.AstNode
`length, parent, position`

Fields inherited from class org.mozilla.javascript.Node

`ATTRIBUTE_FLAG, BOTH, CASEARRAY_PROP, CATCH_SCOPE_PROP, CONTROL_BLOCK_PROP, DECR_FLAG, DESCENDANTS_FLAG, DESTRUCTURING_ARRAY_LENGTH, DESTRUCTURING_NAMES, DESTRUCTURING_PARAMS, DESTRUCTURING_SHORTHAND, DIRECTCALL_PROP, END_DROPS_OFF, END_RETURNS, END_RETURNS_VALUE, END_UNREACHED, END_YIELDS, EXPRESSION_CLOSURE_PROP, first, FUNCTION_PROP, GENERATOR_END_PROP, INCRDECR_PROP, ISNUMBER_PROP, JSDOC_PROP, LABEL_ID_PROP, last, LAST_PROP, LEFT, lineno, LOCAL_BLOCK_PROP, LOCAL_PROP, MEMBER_TYPE_PROP, NAME_PROP, next, NON_SPECIALCALL, OBJECT_IDS_PROP, PARENTHESIZED_PROP, POST_FLAG, PROPERTY_FLAG, propListHead, REGEXP_PROP, RIGHT, SKIP_INDEXES_PROP, SPECIALCALL_EVAL, SPECIALCALL_PROP, SPECIALCALL_WITH, TARGETBLOCK_PROP, type, VARIABLE_PROP`

Constructor Summary
`ArrayComprehension()`
`ArrayComprehension(int pos)`
`ArrayComprehension(int pos, int len)`

Method Summary
`void` `addLoop(ArrayComprehensionLoop acl)` Adds a child loop node, and sets its parent to this node.
`AstNode` `getFilter()` Returns filter expression, or `null` if not present
`int` `getFilterLp()` Returns filter left paren position, or -1 if no filter
`int` `getFilterRp()` Returns filter right paren position, or -1 if no filter
`int` `getIfPosition()` Returns position of 'if' keyword, -1 if not present
`java.util.List<ArrayComprehensionLoop>` `getLoops()` Returns loop list
`AstNode` `getResult()` Returns result expression node (just after opening bracket)
`void` `setFilter(AstNode filter)` Sets filter expression, and sets its parent to this node.
`void` `setFilterLp(int lp)` Sets filter left paren position, or -1 if no filter
`void` `setFilterRp(int rp)` Sets filter right paren position, or -1 if no filter
`void` `setIfPosition(int ifPosition)` Sets position of 'if' keyword
`void` `setLoops(java.util.List<ArrayComprehensionLoop> loops)` Sets loop list
`void` `setResult(AstNode result)` Sets result expression, and sets its parent to this node.
`java.lang.String` `toSource(int depth)` Emits source code for this node.
`void` `visit(NodeVisitor v)` Visits this node, the result expression, the loops, and the optional filter.

Methods inherited from class org.mozilla.javascript.ast.Scope
`addChildScope, clearParentScope, getChildScopes, getDefiningScope, getParentScope, getStatements, getSymbol, getSymbolTable, getTop, joinScopes, putSymbol, replaceWith, setParentScope, setSymbolTable, setTop, splitScope`

Methods inherited from class org.mozilla.javascript.ast.Jump
`getContinue, getDefault, getFinally, getJumpStatement, getLoop, setContinue, setDefault, setFinally, setJumpStatement, setLoop`

Methods inherited from class org.mozilla.javascript.ast.AstNode
`addChild, assertNotNull, codeBug, compareTo, debugPrint, depth, getAbsolutePosition, getAstRoot, getEnclosingFunction, getEnclosingScope, getLength, getLineno, getParent, getPosition, hasSideEffects, makeIndent, operatorToString, printList, setBounds, setLength, setParent, setPosition, setRelative, shortName, toSource`

Methods inherited from class org.mozilla.javascript.Node

`addChildAfter, addChildBefore, addChildrenToBack, addChildrenToFront, addChildToBack, addChildToFront, getChildBefore, getDouble, getExistingIntProp, getFirstChild, getIntProp, getJsDoc, getLastChild, getLastSibling, getNext, getProp, getScope, getString, getType, hasChildren, hasConsistentReturnUsage, iterator, labelId, labelId, newNumber, newString, newString, newTarget, putIntProp, putProp, removeChild, removeChildren, removeProp, replaceChild, replaceChildAfter, setDouble, setJsDoc, setLineno, setScope, setString, setType, toString, toStringTree`

Methods inherited from class java.lang.Object
`clone, equals, finalize, getClass, hashCode, notify, notifyAll, wait, wait, wait`

Constructor Detail

### ArrayComprehension

    public ArrayComprehension()

### ArrayComprehension

    public ArrayComprehension(int pos)

### ArrayComprehension

    public ArrayComprehension(int pos,
                              int len)

Method Detail

### getResult

    public AstNode getResult()

  Returns result expression node (just after opening bracket)

### setResult

    public void setResult(AstNode result)

  Sets result expression, and sets its parent to this node.

  Throws:
    `java.lang.IllegalArgumentException` - if result is `null`

### getLoops

    public java.util.List<ArrayComprehensionLoop> getLoops()

  Returns loop list

### setLoops

    public void setLoops(java.util.List<ArrayComprehensionLoop> loops)

  Sets loop list

  Throws:
    `java.lang.IllegalArgumentException` - if loops is `null`

### addLoop

    public void addLoop(ArrayComprehensionLoop acl)

  Adds a child loop node, and sets its parent to this node.

  Throws:
    `java.lang.IllegalArgumentException` - if acl is `null`

### getFilter

    public AstNode getFilter()

  Returns filter expression, or `null` if not present

### setFilter

    public void setFilter(AstNode filter)

  Sets filter expression, and sets its parent to this node. Can be `null`.

### getIfPosition

    public int getIfPosition()

  Returns position of 'if' keyword, -1 if not present

### setIfPosition

    public void setIfPosition(int ifPosition)

  Sets position of 'if' keyword

### getFilterLp

    public int getFilterLp()

  Returns filter left paren position, or -1 if no filter

### setFilterLp

    public void setFilterLp(int lp)

  Sets filter left paren position, or -1 if no filter

### getFilterRp

    public int getFilterRp()

  Returns filter right paren position, or -1 if no filter

### setFilterRp

    public void setFilterRp(int rp)

  Sets filter right paren position, or -1 if no filter

### toSource

    public java.lang.String toSource(int depth)

  Description copied from class: `AstNode`
  Emits source code for this node. Callee is responsible for calling this function recursively on children, incrementing indent as appropriate.

  Note: if the parser was in error-recovery mode, some AST nodes may have `null` children that are expected to be non-`null` when no errors are present. In this situation, the behavior of the `toSource` method is undefined: `toSource` implementations may assume that the AST node is error-free, since it is intended to be invoked only at runtime after a successful parse.

  Overrides:
    `toSource` in class `Scope`
  Parameters:
    `depth` - the current recursion depth, typically beginning at 0 when called on the root node.

### visit

    public void visit(NodeVisitor v)

  Visits this node, the result expression, the loops, and the optional filter.

  Overrides:
    `visit` in class `Scope`
  Parameters:
    `v` - the object to call with this node and its children